var logViewer = {
	
	tree		: null,
	
	ds			: null,
	
	dsLog		: null,
	
	init : function() {
		
		//Load libraries
		const Include=new Components.Constructor('@mozilla.org/moz/jssubscript-loader;1','mozIJSSubScriptLoader');
		const gInc = new Include();
		gInc.loadSubScript("chrome://needlesearch/content/jslib/nsRdfds.js");
		gInc.loadSubScript("chrome://needlesearch/content/jslib/nsRdfLocator.js");
		gInc.loadSubScript("chrome://needlesearch/content/jslib/nsVirtualForm.js");
		gInc.loadSubScript("chrome://needlesearch/content/jslib/nsSniffer.js");
		gInc.loadSubScript("chrome://needlesearch/content/jslib/nsPrefs.js");
		
		//Make a reference to the list
		logViewer.tree = document.getElementById("needlesearch-logviewer-tree");
		
		//And make it the datasource
		var aLogUri = 'file:///' + nsRdfLocator.getLog(true)
		logViewer.dsLog = new nsRdfds.RDFDataSource(aLogUri)
		logViewer.tree.datasources = aLogUri
		
		var aUri = 'file:///' + nsRdfLocator.getUri(true)
		logViewer.ds = new nsRdfds.RDFDataSource(aUri)
		
	},
	
	clear : function () {
		var aRootNode = logViewer.dsLog.getNode(nsRdfds.logURI);
		var children = aRootNode.getChildren();
		var aChild;
		
		var start = new Object();
		var end = new Object();
		var numRanges = logViewer.tree.builderView.selection.getRangeCount();
		nodeKeys = new Array()
		
		for (var t=0; t < numRanges; t++){
			logViewer.tree.builderView.selection.getRangeAt(t,start,end);
			for (var v=start.value; v<=end.value; v++){
			
				aResource = logViewer.tree.builderView.getResourceAtIndex(v)
				nodeKeys[nodeKeys.length] = aResource
				
			}
			
		}
		
		//We have a list of all the keys, let's get rid of them
		children = aRootNode.getChildren();
		while (children.hasMoreElements()) {
			aChild = children.getNext();
			
			//Now loop through the resources
			for ( var i = 0; i < nodeKeys.length; i++ ) {
				aResource = nodeKeys[i]
				if( aResource.EqualsNode( aChild.source ) ) {
					
					logViewer.dsLog.deleteRecursive( aChild )
					
					//Haal de resource uit de Array
					nodeKeys.splice(i, 1)
				}
			}
			
		}
		
		//We now got all the keys we want
		logViewer.dsLog.save()
		return;
	},
	
	doSearch : function ( aTarget ) {
		var start = new Object();
		var end = new Object();
		var numRanges = logViewer.tree.view.selection.getRangeCount();
		
		for (var t=0; t < numRanges; t++){
			
			logViewer.tree.view.selection.getRangeAt(t,start,end);
			
			for (var v=start.value; v<=end.value; v++){
				
				//Get ID & Searchterms from the log file
				aSearchengineID = logViewer.tree.view.getCellText (v, 'ns-treecell-searchengineID')
				searchterms = logViewer.tree.view.getCellText (v, 'ns-treecell-searchterms')
				
				//Get the rest from the NeedleSearchBookmarks file
				aNode = logViewer.ds.getNode(aSearchengineID);
				
				tmp = aNode.getTarget(nsRdfds.aXMLPath + 'label')
			    searchengine = tmp.getValue()
			    
			    tmp = aNode.getTarget(nsRdfds.aXMLPath + 'method')
				method = tmp.getValue()
				
				tmp = aNode.getTarget(nsRdfds.aXMLPath + 'encoding')
				encoding = tmp.getValue()
				
			    tmp = aNode.getTarget(nsRdfds.aXMLPath + 'searchstring')
				searchstring = tmp.getValue()
				
				//nsHistory.add( searchengineID, searchengine, searchterms )
				
				var aVF = new nsVirtualForm(searchstring, aTarget, searchterms, method, encoding)
				if (aVF.isSuccess) {
					aVF.submit()
				} else {
					//Probably it wasn't HTML what was shown
					window._content.location = 'about:blank'
					setTimeout("aVF = new nsVirtualForm('" + searchstring + "', '" + aTarget + "', '" + searchterms + "', '" + method + "', '"+ encoding + "'); aVF.submit()", 250)
				}
			}
		}
	}
	
}